> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# List callout templates

GET https://rest.test.zuora.com/notifications/callout-templates

Queries callout templates. This operation supports querying callout templates for all event types.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/events-and-notifications/notifications/get-callout-templates

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Query parameters

- `start` (integer, optional, default: 1) — The first index of the query result.
- `limit` (integer, optional, default: 20) — The maximum number of results the query should return.
- `eventCategory` (double, optional) — The event category code of a standard event to which the callout templates you want to query relates.
- `eventTypeName` (string, optional) — The name of a Zuora custom event, custom event, or custom scheduled event to which the callout templates you want to query relates.
- `name` (string, optional) — The name of the callout template.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

## Response

### 200

OK

- `data` (list of GETPublicCalloutTemplateResponse, optional)
- `next` (string, optional) — The URI to query the next page of data, e.g. '/notifications/callout-templates?start=21&limit=20'. The start equals request's start+limit, and the limit equals the request's limit. If the current page is the last page, this value is null.

## Errors

### 400 Bad Request Error

Bad Request

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 404 Not Found Error

Not Found

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 405 Method Not Allowed Error

Method Not Allowed

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 415 Unsupported Media Type Error

Unsupported Media Type

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

## Types

### GETPublicCalloutTemplateResponse

- `active` (boolean, optional) — The status of the callout template.
- `calloutAuth` (CalloutAuth, optional) — If `requiredAuth` is `true`, this object is required.
- `calloutBaseurl` (string, optional) — The callout URL.
- `calloutHeaders` (map from string to string, optional, nullable) — Container for custom callout headers. Each custom callout header consists of a header name and a header value.
- `calloutParams` (map from string to string, optional, nullable) — Container for callout parameters sent in the request body. Each callout parameter consists of a parameter name and a parameter value.
- `calloutRetry` (boolean, optional) — Indicates whether to retry the callout when the callout fails.
- `certificate` (string, optional, nullable) — The SSL certificate for the domain of the callout receiver server specified in `calloutBaseurl`.
- `confirmSuccessFromResponseContent` (boolean, optional) — Indicates how Zuora determines whether callout notifications to your system succeed or fail: * If `false`, Zuora determines the result based solely on the HTTP response status code. This is the default value. * If `true`, and the HTTP response status code is 200, Zuora evaluates the callout response and considers the notification successful only if the `Content-Type` header is set to `application/json`, and the response body contains a `success` field set to `true`.
- `contentType` (string, optional) — The callout body format.
- `createdBy` (string, optional) — The ID of the user who created the callout template.
- `createdOn` (datetime, optional) — The time when the callout template was created. Specified in the UTC timezone in the ISO860 format (YYYY-MM-DDThh:mm:ss.sTZD). E.g. 1997-07-16T19:20:30.45+00:00
- `customRequestBody` (string, optional, nullable) — Customized request body.
- `description` (string, optional) — Description for the callout template.
- `eventCategory` (double, optional) — The event category code for the standard event that the callout template relates to. This field is available only if the related event of this callout template is a standard event. For the list of supported standard event category codes, see Standard event category code for events and notifications.
- `eventTypeName` (string, optional) — The name of the custom event that the callout template relates to. This field is available only if the related event of this callout template is a Zuora custom event, custom event, or custom scheduled event.
- `eventTypeNamespace` (enum, optional) — The namespace of the `eventTypeName` field. It indicates who created the event and which namespace the event is assigned to. Supported values are as follows: - `com.zuora.notification`: events that are created by Zuora. This value applies to Zuora custom events. - `user.notification`: events that are created by tenant users. This value applies to custom events and custom scheduled events. This is the default value. This field is available only if the related event of this callout template is a Zuora custom event, custom event, or custom scheduled event.
  - Allowed values: `user.notification`, `com.zuora.notification`
- `hmacAlgorithm` (enum, optional, nullable) — The hash function Zuora uses to generate the signed data for HMAC authentication.
  - Allowed values: `MD5`, `SHA-1`, `SHA-224`, `SHA-256`, `SHA-384`, `SHA-512`
- `hmacData` (string, optional, nullable) — The message to be authenticated for HMAC authentication.
- `hmacKey` (string, optional, nullable) — The header key that Zuora uses to send the header value for HMAC authentication. The header value is specified in the `hmacValue` field and typically contains the signed data.
- `hmacOutputFormat` (enum, optional, nullable) — The format of the signed data for HMAC authentication.
  - Allowed values: `BASE64`, `HEX`
- `hmacSecret` (string, optional, nullable) — The shared secret key that Zuora uses to generate the signed data for HMAC authentication.
- `hmacValue` (string, optional, nullable) — The header value for HMAC authentication. The header key is specified in the `hmacKey` field.
- `httpMethod` (enum, optional) — The HTTP method of the callout.
  - Allowed values: `POST`, `GET`, `PUT`, `PATCH`, `DELETE`
- `id` (string, optional) — The ID of the callout template.
- `name` (string, optional) — The name of the callout template.
- `oauth2ProviderId` (string, optional, nullable) — The ID of the OAuth 2.0 provider in your tenant that provides access tokens for the callout.
- `requiredAuth` (boolean, optional) — Indicates whether Basic authentication is enabled for the callout.
- `requiredOauth2` (boolean, optional) — Indicates whether OAuth 2.0 authentication is enabled for the callout.
- `updatedBy` (string, optional) — The ID of the user who updated the callout template.
- `updatedOn` (datetime, optional) — The time when the callout template was updated. Specified in the UTC timezone in the ISO860 format (YYYY-MM-DDThh:mm:ss.sTZD). E.g. 1997-07-16T19:20:30.45+00:00
- `useCustomRequestBody` (boolean, optional) — Indicates whether to enable the customized request body configured in the `customRequestBody` field.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CalloutAuth

If `requiredAuth` is `true`, this object is required.

- `domain` (string, optional) — The domain of the callout auth.
- `password` (string, optional) — The field is required when `requiredAuth` is `true`.
- `preemptive` (boolean, optional) — Set this field to `true` if you want to enable the preemptive authentication.
- `username` (string, optional) — The field is required when `requiredAuth` is `true`.

## Examples

**Response**

```json
{
  "data": [
    {
      "active": true,
      "calloutBaseurl": "https://www.example.com/callout/AccountEdit",
      "calloutHeaders": null,
      "calloutParams": null,
      "calloutRetry": true,
      "certificate": null,
      "confirmSuccessFromResponseContent": false,
      "contentType": "APPLICATION_JSON",
      "createdBy": "8a90e08282f4ed040182f67bab2902ff",
      "createdOn": "2024-06-17T04:07:13.000 UTC",
      "customRequestBody": null,
      "description": "Callout when an account is edited",
      "eventTypeName": "AccountEdit",
      "eventTypeNamespace": "user.notification",
      "hmacAlgorithm": null,
      "hmacData": null,
      "hmacKey": null,
      "hmacOutputFormat": null,
      "hmacSecret": null,
      "hmacValue": null,
      "httpMethod": "POST",
      "id": "dcc5a61ee76e496c984206131b5b83e7",
      "name": "Account Edit",
      "oauth2ProviderId": null,
      "requiredAuth": false,
      "requiredOauth2": false,
      "updatedBy": "8a90e08282f4ed040182f67bab2902ff",
      "updatedOn": "2024-06-17T04:07:13.000 UTC",
      "useCustomRequestBody": false
    },
    {
      "active": true,
      "calloutBaseurl": "https://www.example.com/callout/AccountDelete",
      "calloutHeaders": null,
      "calloutParams": null,
      "calloutRetry": true,
      "certificate": null,
      "confirmSuccessFromResponseContent": false,
      "contentType": "APPLICATION_JSON",
      "createdBy": "8a90e08282f4ed040182f67bab2902ff",
      "createdOn": "2024-06-17T04:09:03.000 UTC",
      "customRequestBody": null,
      "description": "Callout when an account is deleted",
      "eventTypeName": "AccountDelete",
      "eventTypeNamespace": "user.notification",
      "hmacAlgorithm": null,
      "hmacData": null,
      "hmacKey": null,
      "hmacOutputFormat": null,
      "hmacSecret": null,
      "hmacValue": null,
      "httpMethod": "POST",
      "id": "a745b9dd39154591b6cc618465aeb133",
      "name": "Account Delete",
      "oauth2ProviderId": null,
      "requiredAuth": false,
      "requiredOauth2": false,
      "updatedBy": "8a90e08282f4ed040182f67bab2902ff",
      "updatedOn": "2024-06-17T04:09:03.000 UTC",
      "useCustomRequestBody": false
    }
  ],
  "next": "/notifications/callout-templates?start=21&limit=20"
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/notifications/callout-templates"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/notifications/callout-templates';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/notifications/callout-templates"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/notifications/callout-templates")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/notifications/callout-templates")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/notifications/callout-templates', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/notifications/callout-templates");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/notifications/callout-templates")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```